/************************************************************************/
/* dir_entry.c: The buffer-freeing utilities for directory entries.     */
/*                                                                      */
/* Modification Log:                                                    */
/*                                                                      */
/* 91/05/21     Sze-Ying Wuu: Modifications made for xdi, Rel 1.0       */
/* 91/02/22     /f/osi/others/quipu/uips/pod/RCS/dir_entry.c            */
/*              Isode Interim (6.8)                               	*/
/************************************************************************/

/* $Header: dir_entry.c,v 1.3 91/06/24 14:30:59 sywuu Exp $ */

/*
 *    Original source: ISODE Interim Release 6.8
 *    Changes/additions by: Sze-Ying Wuu, Bellcore, <sywuu@thumper.bellcore.com>
 *
 *               Changes and Additions Copyright (c) 1991 Bellcore
 *                            All Rights Reserved
 *
 *    Permission is granted to copy, modify and redistribute this program
 *    in source or binary form provided that it is not sold for
 *    profit, and all copyright notices, permission and nonwarranty notices 
 *    remain intact.
 *
 *    Bellcore makes no warranty and accepts no liability for this program.
 * 
 *
 *                             ISODE NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#include "dir_entry.h"

/* free directory entry */
int free_dir_entry(entry)
dirEntry entry;
{
  if (entry->entry_name) free(entry->entry_name);
  (void) free_ent_attrs(entry->attrs);
  free((char *) entry);
}

/* free entry attributes */
int free_ent_attrs(attrs)
dirAttrs attrs;
{
  dirAttrs last_attr = 0;
  for (; attrs; attrs = attrs->next) {
    if (attrs->val_seq) free_mod_vals(attrs->val_seq);
    if (attrs->attr_name) free(attrs->attr_name);
    if (last_attr) free((char *) last_attr);
    last_attr = attrs;
  }
}

/* free modification values */
int free_mod_vals(vals)
modVals vals;
{
  modVals last_val = 0;
  for (; vals; vals = vals->next) {
    if (vals->value) free(vals->value);
    if (vals->new_value) free(vals->new_value);
    if (last_val) free((char *)last_val);
    last_val = vals;
  }
}
